<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'Pesos' => '\\StructType\\Pesos',
            'DescAduanera' => '\\StructType\\DescAduanera',
            'Envios' => '\\StructType\\Envios',
            'Bultos' => '\\StructType\\Bultos',
            'BultosSimples' => '\\StructType\\BultosSimples',
            'BultosError' => '\\StructType\\BultosError',
            'Alertas' => '\\StructType\\Alertas',
            'Destinatarios' => '\\StructType\\Destinatarios',
            'DATOSBULTOERRORTYPE' => '\\StructType\\DATOSBULTOERRORTYPE',
            'DATOSREMITENTEETIQUETATYPE' => '\\StructType\\DATOSREMITENTEETIQUETATYPE',
            'DATOSDESTINATARIOETIQUETATYPE' => '\\StructType\\DATOSDESTINATARIOETIQUETATYPE',
            'VAETIQUETATYPE' => '\\StructType\\VAETIQUETATYPE',
            'FICHEROADJUNTOTYPE' => '\\StructType\\FICHEROADJUNTOTYPE',
            'DATOSETIQUETAXMLTYPE' => '\\StructType\\DATOSETIQUETAXMLTYPE',
            'ETIQUETATYPE' => '\\StructType\\ETIQUETATYPE',
            'DATOSBULTOTYPE' => '\\StructType\\DATOSBULTOTYPE',
            'DATOSBULTOSIMPLETYPE' => '\\StructType\\DATOSBULTOSIMPLETYPE',
            'REEMBOLSOTYPE' => '\\StructType\\REEMBOLSOTYPE',
            'PRUEBAENTREGAREDUCIDOTYPE' => '\\StructType\\PRUEBAENTREGAREDUCIDOTYPE',
            'PRUEBAENTREGATYPE' => '\\StructType\\PRUEBAENTREGATYPE',
            'VATYPE' => '\\StructType\\VATYPE',
            'VACNTYPE' => '\\StructType\\VACNTYPE',
            'PESOTYPE' => '\\StructType\\PESOTYPE',
            'DATOSADUANATYPE' => '\\StructType\\DATOSADUANATYPE',
            'ADUANATYPE' => '\\StructType\\ADUANATYPE',
            'DATOSENVIOREDUCIDOTYPE' => '\\StructType\\DATOSENVIOREDUCIDOTYPE',
            'DATOSENVIOCNTYPE' => '\\StructType\\DATOSENVIOCNTYPE',
            'DATOSENVIOCNCODENVIOTYPE' => '\\StructType\\DATOSENVIOCNCODENVIOTYPE',
            'DATOSENVIOTYPE' => '\\StructType\\DATOSENVIOTYPE',
            'DATOSENVIOMULTIBULTOTYPE' => '\\StructType\\DATOSENVIOMULTIBULTOTYPE',
            'DATOSENVIOMODIFTYPE' => '\\StructType\\DATOSENVIOMODIFTYPE',
            'DATOSDESTINATARIOTYPE' => '\\StructType\\DATOSDESTINATARIOTYPE',
            'DATOSDESTINATARIOMODIFTYPE' => '\\StructType\\DATOSDESTINATARIOMODIFTYPE',
            'DATOSDESTINATARIOREEXPTYPE' => '\\StructType\\DATOSDESTINATARIOREEXPTYPE',
            'DATOSDESTINATARIOCNTYPE' => '\\StructType\\DATOSDESTINATARIOCNTYPE',
            'DATOSDESTINATARIOCNENVIOTYPE' => '\\StructType\\DATOSDESTINATARIOCNENVIOTYPE',
            'IDENTIFICACIONREDUCIDOTYPE' => '\\StructType\\IDENTIFICACIONREDUCIDOTYPE',
            'IDENTIFICACIONTYPE' => '\\StructType\\IDENTIFICACIONTYPE',
            'DIRECCIONTYPE' => '\\StructType\\DIRECCIONTYPE',
            'SMSTYPE' => '\\StructType\\SMSTYPE',
            'DATOSREMITENTETYPE' => '\\StructType\\DATOSREMITENTETYPE',
            'DATOSREMITENTECNTYPE' => '\\StructType\\DATOSREMITENTECNTYPE',
            'DATOSREMITENTEMODIFTYPE' => '\\StructType\\DATOSREMITENTEMODIFTYPE',
            'ERRORVALTYPE' => '\\StructType\\ERRORVALTYPE',
            'LISTAERRORESVALIDACIONTYPE' => '\\StructType\\LISTAERRORESVALIDACIONTYPE',
            'DATOSLOGISTICAINVERSATYPE' => '\\StructType\\DATOSLOGISTICAINVERSATYPE',
            'DIRECCIONIPCTYPE' => '\\StructType\\DIRECCIONIPCTYPE',
            'DIRECCIONADICIPCTYPE' => '\\StructType\\DIRECCIONADICIPCTYPE',
            'PERSONALIZADOSTYPE' => '\\StructType\\PERSONALIZADOSTYPE',
            'PERSONALIZADOTYPE' => '\\StructType\\PERSONALIZADOTYPE',
            'ADUANAIPCTYPE' => '\\StructType\\ADUANAIPCTYPE',
            'PIEZASDELCONTENIDOTYPE' => '\\StructType\\PIEZASDELCONTENIDOTYPE',
            'PIEZADELCONTENIDOTYPE' => '\\StructType\\PIEZADELCONTENIDOTYPE',
            'ITEMSORIGINALESTYPE' => '\\StructType\\ITEMSORIGINALESTYPE',
            'ITEMORIGINALTYPE' => '\\StructType\\ITEMORIGINALTYPE',
            'DOCUMENTOSADJUNTOSTYPE' => '\\StructType\\DOCUMENTOSADJUNTOSTYPE',
            'DOCUMENTOADJUNTOTYPE' => '\\StructType\\DOCUMENTOADJUNTOTYPE',
            'FACTURASORIGINALESTYPE' => '\\StructType\\FACTURASORIGINALESTYPE',
            'FACTURAORIGINALTYPE' => '\\StructType\\FACTURAORIGINALTYPE',
            'PreregistroEnvio' => '\\StructType\\PreregistroEnvio',
            'RespuestaPreregistroEnvio' => '\\StructType\\RespuestaPreregistroEnvio',
            'PreregistroEnvioMultibulto' => '\\StructType\\PreregistroEnvioMultibulto',
            'RespuestaPreregistroEnvioMultibulto' => '\\StructType\\RespuestaPreregistroEnvioMultibulto',
            'PreregistroCodExpedicion' => '\\StructType\\PreregistroCodExpedicion',
            'RespuestaPreregistroCodExpedicion' => '\\StructType\\RespuestaPreregistroCodExpedicion',
            'PreregistroCodEnvio' => '\\StructType\\PreregistroCodEnvio',
            'RespuestaPreregistroCodEnvio' => '\\StructType\\RespuestaPreregistroCodEnvio',
            'SolicitudEtiquetaRefCli' => '\\StructType\\SolicitudEtiquetaRefCli',
            'RespuestaSolicitudEtiquetaRefCli' => '\\StructType\\RespuestaSolicitudEtiquetaRefCli',
            'SolicitudEtiquetaExp' => '\\StructType\\SolicitudEtiquetaExp',
            'RespuestaSolicitudEtiquetaExp' => '\\StructType\\RespuestaSolicitudEtiquetaExp',
            'SolicitudEtiqueta' => '\\StructType\\SolicitudEtiqueta',
            'RespuestaSolicitudEtiqueta' => '\\StructType\\RespuestaSolicitudEtiqueta',
            'ValidarDatos' => '\\StructType\\ValidarDatos',
            'RespuestaValidarDatos' => '\\StructType\\RespuestaValidarDatos',
            'PeticionAnular' => '\\StructType\\PeticionAnular',
            'RespuestaAnular' => '\\StructType\\RespuestaAnular',
            'PeticionModificar' => '\\StructType\\PeticionModificar',
            'RespuestaModificar' => '\\StructType\\RespuestaModificar',
            'SolicitudDocumentacionAduanera' => '\\StructType\\SolicitudDocumentacionAduanera',
            'RespuestaSolicitudDocumentacionAduanera' => '\\StructType\\RespuestaSolicitudDocumentacionAduanera',
            'PeticionBaja' => '\\StructType\\PeticionBaja',
            'RespuestaBaja' => '\\StructType\\RespuestaBaja',
            'SolicitudDocumentacionAduaneraCN23CP71' => '\\StructType\\SolicitudDocumentacionAduaneraCN23CP71',
            'RespuestaSolicitudDocumentacionAduaneraCN23CP71' => '\\StructType\\RespuestaSolicitudDocumentacionAduaneraCN23CP71',
            'PeticionGenerarCodigoExpedicion' => '\\StructType\\PeticionGenerarCodigoExpedicion',
            'RespuestaGenerarCodigoExpedicion' => '\\StructType\\RespuestaGenerarCodigoExpedicion',
            'PeticionPreRegistroIdaVta' => '\\StructType\\PeticionPreRegistroIdaVta',
            'RespuestaPreRegistroIdaVta' => '\\StructType\\RespuestaPreRegistroIdaVta',
            'PeticionReexpedicion' => '\\StructType\\PeticionReexpedicion',
            'RespuestaReexpedicion' => '\\StructType\\RespuestaReexpedicion',
            'PeticionModificarAutorizacionPreviaEntrega' => '\\StructType\\PeticionModificarAutorizacionPreviaEntrega',
            'RespuestaModificarAutorizacionPreviaEntrega' => '\\StructType\\RespuestaModificarAutorizacionPreviaEntrega',
            'PeticionPreRegistroCN' => '\\StructType\\PeticionPreRegistroCN',
            'PeticionPreRegistroCNCodEnvio' => '\\StructType\\PeticionPreRegistroCNCodEnvio',
            'RespuestaPreRegistroCN' => '\\StructType\\RespuestaPreRegistroCN',
            'RespuestaPreRegistroCNCodEnvio' => '\\StructType\\RespuestaPreRegistroCNCodEnvio',
            'CalculaTarifa' => '\\StructType\\CalculaTarifa',
            'RespuestaCalculaTarifa' => '\\StructType\\RespuestaCalculaTarifa',
            'PeticionDevolver' => '\\StructType\\PeticionDevolver',
            'RespuestaDevolver' => '\\StructType\\RespuestaDevolver',
        );
    }
}
