<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Alertas StructType
 * @subpackage Structs
 */
class Alertas extends AbstractStructBase
{
    /**
     * The MensajeAlerta
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * - ref: xsd:MensajeAlerta
     * @var string[]
     */
    public $MensajeAlerta;
    /**
     * Constructor method for Alertas
     * @uses Alertas::setMensajeAlerta()
     * @param string[] $mensajeAlerta
     */
    public function __construct(array $mensajeAlerta = array())
    {
        $this
            ->setMensajeAlerta($mensajeAlerta);
    }
    /**
     * Get MensajeAlerta value
     * @return string[]
     */
    public function getMensajeAlerta()
    {
        return $this->MensajeAlerta;
    }
    /**
     * This method is responsible for validating the values passed to the setMensajeAlerta method
     * This method is willingly generated in order to preserve the one-line inline validation within the setMensajeAlerta method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateMensajeAlertaForArrayConstraintsFromSetMensajeAlerta(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $alertasMensajeAlertaItem) {
            // validation for constraint: itemType
            if (!is_string($alertasMensajeAlertaItem)) {
                $invalidValues[] = is_object($alertasMensajeAlertaItem) ? get_class($alertasMensajeAlertaItem) : sprintf('%s(%s)', gettype($alertasMensajeAlertaItem), var_export($alertasMensajeAlertaItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The MensajeAlerta property can only contain items of type string, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set MensajeAlerta value
     * @param string[] $mensajeAlerta
     * @return \StructType\Alertas
     */
    public function setMensajeAlerta(array $mensajeAlerta = array())
    {
        // validation for constraint: list
        if ('' !== ($mensajeAlertaArrayErrorMessage = self::validateMensajeAlertaForArrayConstraintsFromSetMensajeAlerta($mensajeAlerta))) {
            throw new \InvalidArgumentException($mensajeAlertaArrayErrorMessage, __LINE__);
        }
        $this->MensajeAlerta = is_array($mensajeAlerta) ? implode(' ', $mensajeAlerta) : null;
        return $this;
    }
}
