<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DATOSDESTINATARIOCNTYPE StructType
 * @subpackage Structs
 */
class DATOSDESTINATARIOCNTYPE extends AbstractStructBase
{
    /**
     * The Identificacion
     * @var \StructType\IDENTIFICACIONREDUCIDOTYPE
     */
    public $Identificacion;
    /**
     * The DatosDireccion
     * Meta information extracted from the WSDL
     * - ref: xsd:DatosDireccion
     * @var \StructType\DIRECCIONTYPE
     */
    public $DatosDireccion;
    /**
     * The DatosDireccion2
     * Meta information extracted from the WSDL
     * - ref: xsd:DatosDireccion2
     * @var \StructType\DIRECCIONTYPE
     */
    public $DatosDireccion2;
    /**
     * The CP
     * Meta information extracted from the WSDL
     * - base: xs:string
     * - maxLength: 5
     * - minOccurs: 0
     * - ref: xsd:CP
     * @var string
     */
    public $CP;
    /**
     * Constructor method for DATOSDESTINATARIOCNTYPE
     * @uses DATOSDESTINATARIOCNTYPE::setIdentificacion()
     * @uses DATOSDESTINATARIOCNTYPE::setDatosDireccion()
     * @uses DATOSDESTINATARIOCNTYPE::setDatosDireccion2()
     * @uses DATOSDESTINATARIOCNTYPE::setCP()
     * @param \StructType\IDENTIFICACIONREDUCIDOTYPE $identificacion
     * @param \StructType\DIRECCIONTYPE $datosDireccion
     * @param \StructType\DIRECCIONTYPE $datosDireccion2
     * @param string $cP
     */
    public function __construct(\StructType\IDENTIFICACIONREDUCIDOTYPE $identificacion = null, \StructType\DIRECCIONTYPE $datosDireccion = null, \StructType\DIRECCIONTYPE $datosDireccion2 = null, $cP = null)
    {
        $this
            ->setIdentificacion($identificacion)
            ->setDatosDireccion($datosDireccion)
            ->setDatosDireccion2($datosDireccion2)
            ->setCP($cP);
    }
    /**
     * Get Identificacion value
     * @return \StructType\IDENTIFICACIONREDUCIDOTYPE|null
     */
    public function getIdentificacion()
    {
        return $this->Identificacion;
    }
    /**
     * Set Identificacion value
     * @param \StructType\IDENTIFICACIONREDUCIDOTYPE $identificacion
     * @return \StructType\DATOSDESTINATARIOCNTYPE
     */
    public function setIdentificacion(\StructType\IDENTIFICACIONREDUCIDOTYPE $identificacion = null)
    {
        $this->Identificacion = $identificacion;
        return $this;
    }
    /**
     * Get DatosDireccion value
     * @return \StructType\DIRECCIONTYPE|null
     */
    public function getDatosDireccion()
    {
        return $this->DatosDireccion;
    }
    /**
     * Set DatosDireccion value
     * @param \StructType\DIRECCIONTYPE $datosDireccion
     * @return \StructType\DATOSDESTINATARIOCNTYPE
     */
    public function setDatosDireccion(\StructType\DIRECCIONTYPE $datosDireccion = null)
    {
        $this->DatosDireccion = $datosDireccion;
        return $this;
    }
    /**
     * Get DatosDireccion2 value
     * @return \StructType\DIRECCIONTYPE|null
     */
    public function getDatosDireccion2()
    {
        return $this->DatosDireccion2;
    }
    /**
     * Set DatosDireccion2 value
     * @param \StructType\DIRECCIONTYPE $datosDireccion2
     * @return \StructType\DATOSDESTINATARIOCNTYPE
     */
    public function setDatosDireccion2(\StructType\DIRECCIONTYPE $datosDireccion2 = null)
    {
        $this->DatosDireccion2 = $datosDireccion2;
        return $this;
    }
    /**
     * Get CP value
     * @return string|null
     */
    public function getCP()
    {
        return $this->CP;
    }
    /**
     * Set CP value
     * @param string $cP
     * @return \StructType\DATOSDESTINATARIOCNTYPE
     */
    public function setCP($cP = null)
    {
        // validation for constraint: string
        if (!is_null($cP) && !is_string($cP)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cP, true), gettype($cP)), __LINE__);
        }
        // validation for constraint: maxLength(5)
        if (!is_null($cP) && mb_strlen($cP) > 5) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be less than or equal to 5', mb_strlen($cP)), __LINE__);
        }
        $this->CP = $cP;
        return $this;
    }
}
