<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ERRORVALTYPE StructType
 * @subpackage Structs
 */
class ERRORVALTYPE extends AbstractStructBase
{
    /**
     * The Error
     * Meta information extracted from the WSDL
     * - ref: xsd:Error
     * @var string
     */
    public $Error;
    /**
     * The DescError
     * Meta information extracted from the WSDL
     * - ref: xsd:DescError
     * @var string
     */
    public $DescError;
    /**
     * Constructor method for ERRORVALTYPE
     * @uses ERRORVALTYPE::setError()
     * @uses ERRORVALTYPE::setDescError()
     * @param string $error
     * @param string $descError
     */
    public function __construct($error = null, $descError = null)
    {
        $this
            ->setError($error)
            ->setDescError($descError);
    }
    /**
     * Get Error value
     * @return string|null
     */
    public function getError()
    {
        return $this->Error;
    }
    /**
     * Set Error value
     * @param string $error
     * @return \StructType\ERRORVALTYPE
     */
    public function setError($error = null)
    {
        // validation for constraint: string
        if (!is_null($error) && !is_string($error)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($error, true), gettype($error)), __LINE__);
        }
        $this->Error = $error;
        return $this;
    }
    /**
     * Get DescError value
     * @return string|null
     */
    public function getDescError()
    {
        return $this->DescError;
    }
    /**
     * Set DescError value
     * @param string $descError
     * @return \StructType\ERRORVALTYPE
     */
    public function setDescError($descError = null)
    {
        // validation for constraint: string
        if (!is_null($descError) && !is_string($descError)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($descError, true), gettype($descError)), __LINE__);
        }
        $this->DescError = $descError;
        return $this;
    }
}
